#!/bin/sh

#################################################################################
#
#  Rootkit Hunter installer
# --------------------------
#
# Copyright Michael Boelen ( michael AT rootkit DOT nl )
# See LICENSE file for use of this software
#
#################################################################################

INSTALLER_NAME="Rootkit Hunter installer"
INSTALLER_VERSION="0.0.6"
INSTALLER_COPYRIGHT="Michael Boelen"

# Installation dir (please do not change, it's not (yet) dynamic...)
INSTALL_DIR="/usr/local/rkhunter"
INSTALLPREFIX="./files/"

# Install files
INSTALLFILES="
overwrite:check_modules.pl:/usr/local/rkhunter/scripts/check_modules.pl:Perl%%module%%checker
overwrite:check_port.pl:/usr/local/rkhunter/scripts/check_port.pl:Portscanner
overwrite:filehashmd5.pl:/usr/local/rkhunter/scripts/filehashmd5.pl:MD5%%Digest%%generator
overwrite:filehashsha1.pl:/usr/local/rkhunter/scripts/filehashsha1.pl:SHA1%%Digest%%generator
overwrite:rkhunter:/usr/local/bin/rkhunter:RK%%Hunter%%binary
overwrite:rkhunter.conf:/usr/local/etc/rkhunter.conf:RK%%Hunter%%configuration%%file
overwrite:showfiles.pl:/usr/local/rkhunter/scripts/showfiles.pl:Directory%%viewer
overwrite:backdoorports.dat:/usr/local/rkhunter/db/backdoorports.dat:Database%%Backdoor%%ports
overwrite:mirrors.dat:/usr/local/rkhunter/db/mirrors.dat:Database%%Update%%mirrors
overwrite:os.dat:/usr/local/rkhunter/db/os.dat:Database%%Operating%%Systems
overwrite:defaulthashes.dat:/usr/local/rkhunter/db/defaulthashes.dat:Database%%Default%%file%%hashes
overwrite:md5blacklist.dat:/usr/local/rkhunter/db/md5blacklist.dat:Database%%MD5%%blacklisted%%files
overwrite:CHANGELOG:/usr/local/rkhunter/docs/CHANGELOG:Changelog
overwrite:README:/usr/local/rkhunter/docs/README:Readme%%and%%FAQ
overwrite:WISHLIST:/usr/local/rkhunter/docs/WISHLIST:Wishlist%%and%%TODO
"

# Create directories (only if they do not exist)
CREATEDIRS="
/usr/local/etc
/usr/local/rkhunter
/usr/local/rkhunter/db
/usr/local/rkhunter/docs
/usr/local/rkhunter/scripts
/usr/local/rkhunter/tmp
"

CHECKDIR="/usr/local"


# Functions


searchfile()
  {
    if [ "${PATH}" = "" ]
      then
        PATH="/usr/bin:/usr/local/bin"
    fi
    
#    PATH=`echo ${PATH} | tr ':' ' '`
        
  }




language() {

case $1 in 
	fr)
	t1="Vrification "
	t2="Erreur fatale: "
	t2b="n'existe pas"
	t3="Vrification des outils..."
	t4="Erreur"
	t5="Erreur fatale: Impossible de trouver 'wget' ou 'fetch'"
	t6="Vrification des repertoires d'installation"
	t7="OK. (Utiliser "
	t8="- Vrification "
	t9="Existe"
	t10="Cre"
	t11="Vrification de la configuration systme"
	t12="Echou"
	t13="est introuvable. Crez un lien symbolique vers votre binaire perl"
	t14="Installation des fichiers"
	t15="Installation "
	t16="Echou (impossible de trouver "
	t17="Installation termine"
	t18="Voir /usr/local/rkhunter/docs pour plus d'information. Lancez 'rkhunter'"
	t19="Installation echoue"
	;;
	
	en)
	t1="Checking "
	t2="Fatal error: "
	t2b="doesn't exists"
	t3="Checking file retrieval tools..."
	t4="Error"
	t5="Fatal error: Cannot find 'wget' or 'fetch'"
	t6="Checking installation directories..."
	t7="OK. (Using "
	t8="- Checking "
	t9="Exists"
	t10="Created"
	t11="Checking system settings..."
	t12="Failed"
	t13="cannot be found. Please create a symbolic link to your Perl binary"
	t14="Installing files..."
	t15="Installing "
	t16="Failed (cannot find "
	t17="Installation ready."
	t18="See /usr/local/rkhunter/docs for more information. Run 'rkhunter'"
	t19="Install Failed"
	;;

	nl)
	t1="Bezig met controleren "
	t2="Fatale fout: "
	t2b="bestaat niet"
	t3="Bezig met controleren van download-hulpmiddelen..."
	t4="Fout"
	t5="Fatale fout: can 'wget' of 'fetch' niet vinden"
	t6="Bezig met het controleren van de installatiedirectories..."
	t7="OK. (Gebruiken van "
	t8="- Bezig met controleren "
	t9="Bestaat"
	t10="Aangemaakt"
	t11="Bezig met controleren van de systeeminstellingen..."
	t12="Faalde"
	t13="kan niet gevonden worden. Maak een symbolische link naar de Perl binary"
	t14="Bezig met het installeren van bestanden..."
	t15="Bezig met installeren "
	t16="Faalde (kan bestand niet vinden: "
	t17="Installatie afgerond."
	t18="Bekijk /usr/local/rkhunter/docs voor meer informatie. Start 'rkhunter'"
	t19="Installatie faalde"
	;;

	sp)
	t1="Comprobacin " 
 	t2="Error fatal: "
	t2b="no exista" 
  	t3="Comprobacin de las herramientas ..." 
   	t4="Error" 
        t5="Error fatal: Imposible de encontrar 'wget' ou 'fetch'" 
        t6="Comprobacin directorios  de instalacin " 
        t7="OK. (Utilisar " 
        t8="- Comprobacin " 
        t9="Exista" 
       t10="Crea" 
       t11="Comprobacin de la configuracin sistema" 
       t12="Fallado" 
       t13="no encontrado. Crear un vnculo simblico hacia vuestro binario perl" 
       t14="Instalacin de los ficheros " 
       t15="Instalacin " 
       t16="Fallado (imposible de encontrar " 
       t17="Instalacin terminada" 
       t18="Ver /usr/local/rkhunter/docs para ms informacin . Lanzar 'rkhunter'"
       t19="Instalacin Fallado"
       ;;

       se)
        t1="kollar "
        t2="allvarligt fel: "
        t2b="finns inte"
        t3="undersker fil hmtnings verktyg ..."
        t4="fel"
        t5="Allvarligt fel: kan inte hitta 'wget' eller 'fetch'"
        t6="kollar installations katalogen..."
        t7="OK. (anvnder "
        t8="- kollar "
        t9="finns"
        t10="skapad"
        t11="kollar system instllningar..."
        t12="avbruten"
        t13="kan inte hittas. skapa en symlnk till Perl binren"
        t14="Installerar filer..."
        t15="Installerar "
        t16="Misslyckades (kan inte hitta "
        t17="Installation r klar."
        t18="kolla p /usr/local/rkhunter/docs fr mer information. kr 'rkhunter'"
        t19="Installtionen misslyckades"
        ;;
esac
}

if [ -f ~/.rkhunterlng ]
then
   lng=`cat ~/.rkhunterlng`
     case $lng in
        "en") rep="ok";;
        "fr") rep="ok";;
	"nl") rep="ok";;
	"se") rep="ok";;
        "sp") rep="ok";;
	*) echo "Language not supported"
              rm -f ~/.rkhunterlng
              exit 1 ;;
     esac
else
     lng="en"
fi     

#     rep="nok"
#     while [ "$rep" = "nok" ]
#     do
#     	echo -n "Language file not detected, which language do you want to use (en/fr/nl/se/sp) ?"
#     	read lng
#             case $lng in
#	            "en") rep="ok";;
#                    "fr") rep="ok";;
#		    "nl") rep="ok";;
#		    "se") rep="ok";;
#	            "sp") rep="ok";;   
#		       *) echo "Language not supported";;
#	     esac
#     done
#  	touch ~/.rkhunterlng
#   	echo $lng > ~/.rkhunterlng


language $lng
																	
#################################################################################
#
# Start installation
#
#################################################################################


# Clean active window
clear

echo "${INSTALLER_NAME} ${INSTALLER_VERSION} (${INSTALLER_COPYRIGHT})"
echo "---------------"
echo "Starting installation/update"
echo ""

echo -n "Checking UID... "
if [ `id -u` = "0" ]
  then
    echo "OK"
  else
    echo "Sorry, you have to be 'root'. Please su(do) and try again"
fi

echo -n "$t1 ${CHECKDIR}..."
if [ -d ${CHECKDIR} ]
  then
    echo -e "OK"
  else
    echo "$t2 ${CHECKDIR} $t2b"
    exit 1
fi

echo -n "$t3 "
SEARCH=`which wget`

if [ "${SEARCH}" = "" ]
then
    SEARCH=`which fetch`
    	if [ "${SEARCH}" = "" ]
      	then
        	echo -e "${t4}"
		echo "$t5"
		exit
      	else
        	RETRTOOL=${SEARCH}
    	fi
else
    RETRTOOL=${SEARCH}
fi


echo ${RETRTOOL}

echo "$t6"
for I in ${CREATEDIRS}; do
  echo -n "$t8${I}..."
  if [ -d ${I} ]
    then
      echo -e "$t9"
    else
      echo -e "$t10"
      # Create directory
      mkdir -p ${I}
  fi
done

echo "$t11"
echo -n "    - Perl... "
if [ ! -f /usr/bin/perl ]
  then
    echo -e  "$t12"
    echo ""
    echo "----------------------------------------------------------------------------------"
    echo "/usr/bin/perl $t13"
    echo "ie. ln -s <path_to>/perl /usr/bin/perl"
    echo "----------------------------------------------------------------------------------"
  else
    echo -e "OK"
fi


echo "$t14 "

for I in ${INSTALLFILES}; do
  
  INSTALLTYPE=`echo ${I} | cut -d ':' -f1`
  CURFILE=`echo ${I} | cut -d ':' -f2`
  NEWFILE=`echo ${I} | cut -d ':' -f3`
  DESCRIPTION=`echo ${I} | cut -d ':' -f4 | tr -s '%%' ' '`

  echo -n "$t15 ${DESCRIPTION}..."
  if [ -f ${INSTALLPREFIX}${CURFILE} ]
    then
      #error redirection in .rkhunter it's just for a clear display if user run not as root
      cp -f ${INSTALLPREFIX}${CURFILE} ${NEWFILE} 2> ~/.rkhunter.log
      if [ $? -eq 0 ]
        then
	  echo -e "OK"
	  INSTALL="ok"
	else
	  echo -e "$t12 "
	  INSTALL="nok"
      fi
    else
      echo "$t16${CURFILE})"
  fi
 
done

if [ ${INSTALL} != "nok" ]
then
	echo ""
	echo -e "$t17"
	echo "$t18 (/usr/local/bin/rkhunter)"
else
	echo ""
	echo -e "$t19"
	echo "Check ~/.rkhunter.log"
fi

# The End
